import numpy as np
import time
import random
import os
import threading
obstacle = 1
chance = [1,1,1,0,0,0,0,0,0,0,0,0,0]

class myThread (threading.Thread):   #继承父类threading.Thread
    def __init__(self, threadID,cla):
        threading.Thread.__init__(self)
        self.threadID = threadID
        self.cla = cla
    def run(self):                   #把要执行的代码写到run函数里面 线程在创建后会直接运行run函数
        self.cla.change_map()

class find_road:
    def __init__(self,map1,map2,x,y):
        self.map1 =map1.copy()
        self.map2 = map2
        self.map = map1
        shape = np.shape(self.map)  # 注意x为第几行，y为第几列
        self.row = shape[1]
        self.line = shape[0]
        self.four = 0
        self.two = 0
        self.x = x - 1
        self.num = 4
        self.y = y - 1
        self.loading = []
        self.road = list()
        self.end = -1
        self.get = []

    def change_map(self):
        step = 1
        while k:
            time.sleep(10)
            map = self.map
            x = self.mx
            y = self.my
            map[x][y] = 0

            if step == 1:
                map += self.map2
                step = 0
            else:
                step = 1
                map -= self.map2
            if map[x][y] != 0:
                if map[x-1][y] == 0:
                    map[x - 1][y] = 3
                elif map[x+1][y] == 0:
                    map[x + 1][y] = 3
                elif map[x][y-1] == 0:
                    map[x][y - 1] = 3
                elif map[x][y+1] == 0:
                    map[x][y + 1] = 3
            else:
                map[x][y] = 3
            self.map = map
            print("call")

    def get_nodes(self):
        self.nodes = [[self.x * self.row + self.y]]

    def find_next_nodes(self,node,generation):
        next_nodes = list()
        x,y = self.get_position(node)
        next_nodes.append([x-1,y])
        next_nodes.append([x+1,y])
        next_nodes.append([x,y+1])
        next_nodes.append([x,y-1])
        for i,j in next_nodes:
            n = i *self.row + j
            if len(self.nodes) != generation + 1:
                self.nodes.append([])
            if self.map[i][j] != 1 and n not in self.nodes[generation - 1] and n not in self.nodes[generation-2]\
                    and n not in self.nodes[-1]:
                self.nodes[generation].append(n)

    def get_position(self,value):
        y = value % self.row
        x = int((value - y) / self.row)
        return x,y

    def is_find(self,target):
        find = False

        for value in self.nodes[-1]:
            x,y = self.get_position(value)
            if self.map[x][y] == target:
                self.end = x * self.row + y
                find = True
                break
        return find

    def is_road(self,this_value,end_value):
        road = False
        if abs(this_value - end_value) == 1 or \
           abs(this_value - end_value) == self.row:
            road = True
        return road


    def begin_search(self):
        self.get_four = False
        self.get_two = False
        move = True
        road2 = None
        end2 = None
        road4 = None
        end4 = None
        self.print_to_screen()
        target = 2
        while self.num >0:
            self.get_nodes()
            gen = 1
            if target == 5 and len(self.loading) == 0:
                target = 2
            if (len(self.loading) + len(self.get)) == 4:
                target = 5
            while not self.is_find(target):
                for node in self.nodes[gen-1]:
                    self.find_next_nodes(node,gen)
                gen += 1

            self.draw_road()
            if (self.loading.count(2) + self.get.count(2))== 3:
                self.get_two = True
            if (self.loading.count(4) + self.get.count(4)) == 1:
                self.get_four =True
            if len(self.loading) == 2:
                target = 5
                self.move()
                continue
            elif self.get_four or self.get_two:
                if self.get_two:
                    if not self.get_four:
                        target = 4
                else:
                    if not self.get_two:
                        target = 2
                self.move()
                continue
            else:
                if target == 2: #计算2、4路径
                    target = 4
                    road2 = self.road.copy()
                    end2 = self.end
                    self.two = len(self.road)
                    move = not move
                else:
                    target = 2
                    road4 = self.road.copy()
                    end4 = self.end
                    self.four = len(self.road)
                    move = not move
                if move:
                    if self.two >= self.four:
                        self.road = road4
                        self.end = end4
                    else:
                        self.road = road2
                        self.end = end2
                    self.move()

            self.road = []




    def draw_road(self):
        gen = len(self.nodes) - 2
        end = self.end
        self.road.append(self.end)
        while gen >= 0:
            for n in self.nodes[gen]:
                if self.is_road(n,end):
                    self.road.append(n)
                    gen -= 1
                    end = n
                    break

    def move(self):
        n_x,n_y = self.get_position(self.road[-2])
        p_x,p_y = self.get_position(self.road[-3])
        self.mx = n_x
        self.my = n_y
        if self.map[22][22] != 5 and self.map[22][22] != 3:
            self.map[22][22] = 5

        if [p_x,p_y] == list(self.get_position(self.end)):
            if self.map[p_x][p_y] == 2:
                if chance.pop(random.randint(0,len(chance)-1)) == 1:
                    self.loading.append(2)

            if self.map[p_x][p_y] == 4:
                self.loading.append(4)
                self.get_four = True
            if self.map[p_x][p_y] == 5:
                for i in range(2):
                    self.get.append(self.loading.pop(0))
                self.num -= 2
        self.map[p_x][p_y] = 0
        self.map[self.x][self.y] = 0
        self.map[n_x][n_y] = 3
        self.x = n_x
        self.y = n_y
        self.print_to_screen()
        time.sleep(0.1)

    def print_to_screen(self):
        os.system("CLS")
        print("load:", self.loading)
        print("get:",self.get)
        print(chance)
        for x in range(self.line):
            for y in range(self.row):
                if self.map[x][y] == 0:
                    print(" ",end=" ")
                if self.map[x][y] == 1:
                    print("#",end=" ")
                if self.map[x][y] == 2:
                    print("$",end=" ")
                if self.map[x][y] == 3:
                    print("&",end=" ")
                if self.map[x][y] == 4:
                    print("+",end=" ")
                if self.map[x][y] == 5:
                    print("=",end=" ")
            print("")





if __name__ == "__main__":
    map1 = [[1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1],
            [1, 3, 0, 0, 1, 2, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 2, 1, 0, 0, 0, 1],
            [1, 1, 1, 0, 1, 1, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1],
            [1, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 1, 2, 1, 0, 0, 0, 1, 0, 0, 0, 1],
            [1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 0, 1],
            [1, 2, 1, 2, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 2, 0, 0, 1, 0, 0, 2, 1, 0, 1],
            [1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 0, 1],
            [1, 0, 0, 0, 0, 0, 1, 2, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1],
            [1, 1, 1, 1, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1],
            [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 4, 1, 0, 0, 0, 1, 2, 0, 0, 0, 0, 1],
            [1, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1],
            [1, 0, 0, 0, 1, 2, 0, 0, 1, 0, 0, 0, 1, 2, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1],
            [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1],
            [1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1],
            [1, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1],
            [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1],
            [1, 1, 1, 1, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1],
            [1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1],
            [1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 0, 1],
            [1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1],
            [1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 0, 1],
            [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1],
            [1, 1, 1, 0, 1, 1, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 5, 0, 1],
            [1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1],
            [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]]
    map2 = [[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0],
               [0, -1, 0, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, -1, -1, 0],
               [0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0],
               [0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]]

map1 = np.array(map1)
map2 = np.array(map2)
k = True

test = find_road(map1,map2,2,2)
thred = myThread(1,test)
thred.start()
test.begin_search()
k = False